/*---------------------------------------------------------------------------
  [UNIX/DOS] Base include (C VERSION!)
 ---------------------------------------------------------------------------*/
#ifndef _BASE_H_
#define _BASE_H_
#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char uint8;
typedef signed char sint8;
typedef unsigned short uint16;
typedef signed short sint16;
typedef unsigned int uint32;
typedef signed int sint32;

#ifndef __cplusplus
typedef int bool;
#endif
typedef uint8 byte;
typedef uint16 word;
typedef uint32 dword;
typedef sint8 intb;
typedef sint16 intw;
typedef sint32 intd;

#ifndef NULL
#ifndef __cplusplus
#define NULL ((void*)0)
#else
#define NULL (0)
#endif
#endif

#ifndef TRUE
#define TRUE  ((bool)1)
#endif
#ifndef FALSE
#define FALSE ((bool)0)
#endif

#ifndef __OSUNIX__
#define PATH_SLASH '\\'
#define PATH_SLASH_STR "\\"
#else
#define PATH_SLASH '/'
#define PATH_SLASH_STR "/"
#endif

#ifdef _DEBUG
  #define DEBUG
#endif

#ifndef ASSERT
  #ifdef _ASSERT
    #define ASSERT(x) _ASSERT(x)
  #else
    #include <assert.h>
    #define ASSERT(x) assert(x)
  #endif
#endif

#ifdef __cplusplus
};
#endif
#endif


