/***************************************************************************
                          multiplex.cpp  -  description
                             -------------------
    begin                : |DATE|
    copyright            : (C) |YEAR| by |AUTHOR|
    email                : tuvisionlib@tuvision.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CImageByteRGB.h"
#include "tuv/CImageByteGray.h"
#include "tuv/CFileReadJpeg.h"
#include "tuv/CFileWriteJpeg.h"
#include "tuv2d/COperatorMultiplex.h"

#include <cstdio>
#include <iostream>


using namespace std;
using namespace TUVision;

int main (void)
{
    CImageByteRGB            *img_rgb;
    CFileReadJpeg            jpeg_read;
    CFileWriteJpeg           jpeg_write;
    COperatorMultiplex       mux;
    vector <CImageByteGray*> img_dmux;
    unsigned int   i;
    char  tmp[100];


    // Read 8 bit rgb JPEG image: "test.jpg".
    try {
        jpeg_read.open ("test.jpg");
        img_rgb = dynamic_cast<CImageByteRGB*> (jpeg_read.read());

        if (img_rgb == NULL)
            cerr << "Cannot read JPEG file!" << endl << endl;

        jpeg_read.close();
    } 
    catch (CException &e) { 
        cerr << e.what() << endl;
        return (1);
    } 

    // Demultiplex RGB image to three gray level images.
    mux.demultiplex (*img_rgb, img_dmux);

    // Save all gray level images as JPEG files.
    try 
    {
        for (i = 0; i < img_dmux.size(); i++)
        {
            sprintf (tmp, "test%u.jpg", i);
            jpeg_write.open (tmp);
            jpeg_write.setQuality (50);
            jpeg_write.write (*(img_dmux[i]));
            jpeg_write.close();
        }
    } 
    catch (CException &e) 
    {
        cerr << e.what() << endl;
        return (1);
    } 


    return (0);
}

