/***************************************************************************
                          cline.h  -  description
                             -------------------
    begin                : Die May 7 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : tuvisionlib@tuvision.de, wenzel@tu-harburg.de
    origin               : PhD Fabian Wenzel

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef CLINE_H
#define CLINE_H

#include <vector>
#include <tuv/CVertex.h>

typedef std::vector< TUVision::CVertex2d > Tpointlist;

class CLine {
public:
    // Exports for RANSAC : Its defining Datatype, codimension and minimum
    // number of building data
    typedef std::vector< TUVision::CVertex2d > TDataVector;
    enum { codimension=1 };
    enum { minimumdata=2 };


    CLine ( const TDataVector &list );
    ~CLine();

    // Distance of a point pair to the internal model
    double calculateDistance( const TDataVector::value_type &sample );
private:
    TUVision::CVertex2d m_normalvector;
    double              m_distance;
};

#endif
