/***************************************************************************
                          CExceptionEssential.h  -  description
                             -------------------
    begin                : 16.04.2003
    copyright            : (C) 2001 by Thomas Beilicke
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Thomas Beilicke

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CEXCEPTIONESSENTIAL_H__
#define __TUVISION_CEXCEPTIONESSENTIAL_H__ 1

#include "CException.h"
#include "TUVisionDef.h"

namespace TUVision {

/**********************************************************/
//!  Error within CEssentialMatrix algorithms
/*!
 *   This class defines exceptions that can occur within 
 *   algorithms of CEssentialMatrix. The type is given
 *   by an enumeration.
 *
 *   \ingroup exception
 *
 *   \author Thomas Beilicke
 */
/**********************************************************/

class _CCTUVISION CExceptionEssential : public CException { 
public:
    CExceptionEssential(const std::string &what, int type) : CException(what) {this->type=type;}
    CExceptionEssential(int type) : CException() {this->type=type;}
    int getType() {return type;}	//!< Returns the type of the error. See types enumeration.
    enum types{NOSOLUTION, TOOMANYSOLUTIONS};	//!< No possible solution found for camera / more than one solution found.
private:
    int type;	//!< The type of the error.
};

}

#endif
