/***************************************************************************
                          CExceptionIllegalPoint.h  -  description
                             -------------------
    begin                : 11.03.2003
    copyright            : (C) 2001 by Thomas Beilicke
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Thomas Beilicke

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CEXCEPTIONILLEGALPOINT_H__
#define __TUVISION_CEXCEPTIONILLEGALPOINT_H__ 1

#include "CException.h"
#include "TUVisionDef.h"

namespace TUVision {

/**********************************************************/
//!  Error retrieving CCorrespondence point.
/*!
 *   This class defines exceptions that can occur when using 
 *   the checking aspect of CCorrespondence and the wanted
 *   point is illegal (direction) or has not been calculated.
 *
 *   \ingroup exception
 *
 *   \author Thomas Beilicke
 */
/**********************************************************/
class _CCTUVISION CExceptionIllegalPoint : public CException { 
public:
    CExceptionIllegalPoint(const std::string &what) : CException(what) {}
    CExceptionIllegalPoint() : CException() {}
};

}

#endif
