/***************************************************************************
                          CFileWriteGnuplot3D.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILEWRITEGNUPLOT3D_H_
#define __TUVISION_CFILEWRITEGNUPLOT3D_H_ 1

#include <fstream>

#include "tuv/CFileWrite.h"
#include "tuv/CImageByteGray.h"
#include "tuv/CException.h"


namespace TUVision {

/**********************************************************/
/*! 
 *   This class saves an images as gnuplot data file.   
 *   The file could be plotted by gnuplot's "splot"
 *   command.
 *
 *   \ingroup io
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CFileWriteGnuplot3D: public CFileWrite {

public:
    CFileWriteGnuplot3D (void);
    ~CFileWriteGnuplot3D();

    void open (const std::string &filename)
        throw (CException);

    void close (void)
        throw();

    /******************************************************/
    //!  Save 8 bit gray image.
    /******************************************************/
    void write (const CImageByteGray &img)
        throw (CException);


private:
    std::ofstream  hd;         //!< file I/O class
};

}

#endif
