/***************************************************************************
                          CGeneratorZoneplate.h  -  description
                             -------------------
    begin                : 19.11.2001
    copyright            : (C) 2001 by Thomas Beilicke, Fabian Wenzel
    email                : tuvisionlib@tuvision.de
    origin               : Digitale Bildverarbeitung 1, WS 2001/2001

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CGENERATORZONEPLATE_H__
#define __TUVISION_CGENERATORZONEPLATE_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

namespace TUVision {

/******************************************************************************/
//! Generates a zone plate pattern
/*! \class CGeneratorZoneplate CGeneratorZoneplate.h tuv/CGeneratorZoneplate.h
 ******************************************************************************/
class _CCTUVISION CGeneratorZoneplate{
public:
    //! Constructor, initializes the parameters
    CGeneratorZoneplate();

    //! Generates Sine-ZonePlate
    CImageByteGray* sinPlate(int width, int height);

    //! generates Ramp-ZonePlate
    CImageByteGray* rampPlate(int width, int height);

    //! generates Ramp-ZonePlate // sets the amplitude-interval
    void setAmplitudeInterval(unsigned char low, unsigned char high);
private:

    //! calculates the Ramp-Function
    double ramp(double phase);

    //! Average of the phase
    double d_k0;

    //! Cycles per width
    double d_kx;

    //! Cycles per height
    double d_ky;

    //! Horizontal linear frequency
    double d_kx2;

    //! Vertical linear frequency
    double d_ky2;

    //! Hyperbola
    double d_kxy;

    unsigned char d_rLow;

    unsigned char d_rHigh;
};

}
#endif // __TUVISION_CGENERATORZONEPLATE_H__
