/***************************************************************************
                          CImageDatatypes.h  -  description
                             -------------------
    begin                : 01.08.2002
    copyright            : (C) 2001 by Tobias Frommfeld
    email                : tuvisionlib@tuvision.de
    origin               : Studienarbeit Tobias Frommfeld

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CIMAGEDATATYPES_H__
#define __TUVISION_CIMAGEDATATYPES_H__ 1

#include <complex>
#include "tuv/CImage.h"
#include "tuv/CImageType.h"
#include "tuv/CImageTemplate.h"

namespace TUVision {
typedef unsigned char	Byte;

typedef CImageType<Byte>                              CImageByte;
typedef CImageTemplate<Byte, Gray >                   CImageByteGray;
typedef CImageTemplate<Byte, Bilevel >                CImageByteBilevel;
typedef CImageTemplate<Byte, RGB >                    CImageByteRGB;
typedef CImageTemplate<Byte, YUV >                    CImageByteYUV;

typedef CImageType<int>                               CImageInt;
typedef CImageTemplate<int, Gray >                    CImageIntGray;
typedef CImageTemplate<int, Bilevel >                 CImageIntBilevel;
typedef CImageTemplate<int, RGB >                     CImageIntRGB;
typedef CImageTemplate<int, YUV >                     CImageIntYUV;

typedef CImageType<double>                            CImageDouble;
typedef CImageTemplate<double, Gray >                 CImageDoubleGray;
typedef CImageTemplate<double, Bilevel >              CImageDoubleBilevel;
typedef CImageTemplate<double, RGB >                  CImageDoubleRGB;
typedef CImageTemplate<double, YUV >                  CImageDoubleYUV;

typedef CImageType<std::complex<double> >             CImageComplex;
typedef CImageTemplate<std::complex<double>, Gray >   CImageComplexGray;

}
#endif // __TUVISION_CIMAGEDATATYPES_H__



