/***************************************************************************
                          CEllipse.h  -  description
                             -------------------
    begin                : 21.9.2002
    copyright            : (C) 2002 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CELLIPSE_H_
#define __TUVISION_CELLIPSE_H_

#include "tuv2d/CShape.h"
#include "TUVisionDef.h"

namespace TUVision {

class _CCTUVISION CEllipse : public CShape{
    //private
    int d_h,d_w;    //! the width and height of search window of the parabola

    //construct
public:
    //! defult constructor
    CEllipse(){};

    //! construct a Parabola object with w width and h heignt and the threshold
    CEllipse(int w,int h,int x_direction = +1, double thr0 = 0.2, double thr1 = 0.8);

    //! get the parabola width
    int getW(){ return d_w;};

    //! get the parabola height
    int getH(){ return d_h;};



    //set
    void setEllipses();
    void setEllipses(int c0, int c1, double BA = 0.85, double direction = 0,
        int Q1 = 1, int Q2 = 1,int Q3 = 1,int Q4 = 1, int OriginPosition = 0, int step = 1);

    //public variable
    double m_rTh0, m_rTh1; /// the ratio of the 0, 1 threshold  

};

} //namespace TUVision
#endif // __TUVISION_CPARABOLA_H_
