/***************************************************************************
                          CFilterRGB.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILTERRGB_H__
#define __TUVISION_CFILTERRGB_H__ 1

#include "TUVisionDef.h"
#include "tuv2d/CFilterByteRGB.h"
#include "tuv2d/CFilterIntRGB.h"
#include "tuv2d/CFilterDoubleRGB.h"


namespace TUVision 
{
/**********************************************************/
//!  A generic filter for RGB level images.
/*! 
 *   This base class defines a generic image filter for
 *   RGB level images. You can derive filters from this
 *   class that are supporting RGB level input/output
 *   images.
 *
 *   The real filtering takes place in the filter()
 *   function. This function has to be implemented in
 *   the derived filter classes. A filtered image has got
 *   always the same properties (i.e. width, height,
 *   number format, and color model) as the source image.
 *
 *   \ingroup filter
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CFilterRGB : public CFilterByteRGB, 
    public CFilterIntRGB,
    public CFilterDoubleRGB {
    };

}
#endif // __TUVISION_CFILTERRGB_H__
