/***************************************************************************
                          CFilterSobel.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILTERSOEBEL_H__
#define __TUVISION_CFILTERSOEBEL_H__ 1

#include "tuv2d/CFilterByteGray.h"
#include "tuv2d/CFilterIntGray.h"
#include "tuv2d/CFilterDoubleGray.h"

#include "TUVisionDef.h"
//#include "filter/CFilterGray.h"


namespace TUVision 
{

/**********************************************************/
//!  Sobel filter (edge detection)
/*! 
 *   This class implements the Sobel filter used for
 *   edge detection. A description of this filter could
 *   be found in Pratt's "Digital Image Processing".
 *
 *   \ingroup filter
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CFilterSobel : public CFilterByteGray, 
    public CFilterIntGray ,
    public CFilterDoubleGray 
{

public:
    void filter (CImageByteGray &img);
    void filter (CImageIntGray &img);
    void filter (CImageDoubleGray &img);
};


} 

#endif // __TUVISION_CFILTERSOEBEL_H__
