/***************************************************************************
                          CFilterThinning.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILTERTHINNING_H__
#define __TUVISION_CFILTERTHINNING_H__ 1

#include "tuv2d/CFilterBilevel.h"
#include "TUVisionDef.h"


namespace TUVision 
{

/**********************************************************/
//!  Thinning filter
/*! 
 *   This class implements a thinning filter. A 
 *   description of this filter could be found in 
 *   Gonzalez, "Digital Image Processing", page 492.
 *
 *   \ingroup filter
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CFilterThinning : public CFilterBilevel {

public:
    void filter (CImageByteBilevel &img);
};


} 

#endif // __TUVISION_CFILTERTHINNIG_H__
