/***************************************************************************
                          CLine.h  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CLINE_H_
#define __TUVISION_CLINE_H_ 1

#include "tuv2d/CShape.h"
#include <vector>
#include "TUVisionDef.h"

namespace TUVision {
class CCurve;
class CPointXY;

class _CCTUVISION CLine :public CShape{
    //private
    double d_t0;//! the start slope angle of the line shapes
    double d_t1;//! the end slope angle of the line shapes


public:
    //! construct a line shape each line length is 10 and angle res 1 degree
    CLine(int w = 10,double res = 1, double t0=0.0, double t1=180.0);

    virtual ~CLine();

    std::vector<CCurve>::iterator itToLineOf(int,int);
    std::vector<CCurve>::iterator itToLineOf(const CPointXY&);

    //! construct a line shape each line length is 10 and angle res 1 degree
    void setLineShape(int w = 10,double res = 1,double t0=0.0, double t1=180.0);

private:
    //! I will remove it soon
    void setWindowShape(int w = 10);

};
}; //namespace TUVision
#endif //__TUVISION_CLINESHAPE_H_
