/***************************************************************************
                           COperatorFlipImage.h  -  description
                              -------------------
     begin                : 18.06.2002
     copyright            : (C) 2002 Marc Hensel
     email                : tuvisionlib@tuvision.de, marc.hensel@web.de
     origin               : Study thesis Marc Hensel
 
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef __TUVISION_COPERATORFLIPIMAGE_H__
#define __TUVISION_COPERATORFLIPIMAGE_H__	1

#include <tuv/CImageByteGray.h>
#include <tuv/CImageByteRGB.h>
#include <TUVisionDef.h>

namespace TUVision 
{

/**********************************************************/
//!  Flip images.
/*! 
 *   Flip images horizontal and/or vertical.
 *
 *   \ingroup operator
 *
 *   \author Marc Hensel
 *
 *   \class COperatorFlipImage COperatorFlipImage.h tuv2d/COperatorFlipImage.h
 */
/**********************************************************/

class _CCTUVISION COperatorFlipImage
{
private:

public:
    //! Constructor
    COperatorFlipImage	();

    //! Destructor
    ~COperatorFlipImage	();

    //! Flip the image
    void		flip	(CImageByteGray *img,bool horizontal,bool vertical);
    void		flip	(CImageByteRGB  *img,bool horizontal,bool vertical);
};

}

#endif	// __TUVISION_COPERATORFLIPIMAGE_H__
