/***************************************************************************
                           COperatorInvert.h  -  description
                              -------------------
     begin                : 22.08.2002
     copyright            : (C) 2002 Marc Hensel
     email                : tuvisionlib@tuvision.de, marc.hensel@web.de
     origin               : Diploma thesis Marc Hensel
 
***************************************************************************/


/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef __TUVISION_COPERATORINVERT_H__
#define __TUVISION_COPERATORINVERT_H__	1

#include <tuv/CImageByteGray.h>
#include <TUVisionDef.h>

namespace TUVision 
{

/**********************************************************/
//!  Invert an image.
/*! 
 *   \ingroup operator
 *
 *   \author Marc Hensel
 *
 *   \class COperatorInvert COperatorInvert.h tuv2d/COperatorInvert.h
 */
/**********************************************************/

class _CCTUVISION COperatorInvert
{
private:

public:
    //! Constructor
    COperatorInvert		();

    //! Destructor
    ~COperatorInvert	();

    //! Invert a gray 8-bit image, i.e. new_value = 255 - old_value
    void	invertImage		(CImageByteGray *img);
};

}

#endif	// __TUVISION_COPERATORINVERT_H__
