/***************************************************************************
                          COperatorNormalize.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marius Annoff
    email                : tuvisionlib@tuvision.de
    origin               : DA - Marius Annoff

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_COPERATORNORMALIZE_H__
#define __TUVISION_COPERATORNORMALIZE_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

namespace TUVision {

  /**********************************************************/
  //!  Class to calculate image normalization.
  /*!
   *   This class calculates the normalization of a given
   *
   *   \ingroup operator
   *
   *   \author Marius Annoff
   */
  /**********************************************************/

  class _CCTUVISION COperatorNormalize {

    public:

      /******************************************************/
      //! Constructor.
      /******************************************************/
      COperatorNormalize();

      /******************************************************/
      //! Destructor.
      /******************************************************/
      ~COperatorNormalize();

      /******************************************************/
      //! Sets the image to be used (byte gray).
      /******************************************************/
      void normalizeImage (CImageByteGray &img, double avg0, double var0 );

    private:
  };
}

#endif  // __TUVISION_COPERATORNORMALIZE_H_
