/***************************************************************************
                          CParabola.h  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CPARABOLA_H_
#define __TUVISION_CPARABOLA_H_

#include "tuv2d/CShape.h"
#include "tuv2d/CPointXY.h"
#include "tuv2d/CCurve.h"

namespace TUVision {

class _CCTUVISION CParabola:public CShape{
    //private
    int d_h,d_w;    //! the width and height of search window of the parabola

    //! this function will be soon obsilite
    int isParabola(CPointXY &st, CPointXY &en,
        unsigned char *EdgeImage,
        unsigned char *OutImage,
        int x_size, int y_size,
        int& w,int& Thr0,int& Thr1, int del);

    //construct
public:
    //! defult constructor
    CParabola(){};

    //! construct a Parabola object with w width and h heignt
    //		CParabola(int w,int h);

    //! construct a Parabola object with w width and h heignt and the threshold
    CParabola(int w,int h,int x_direction = +1, double thr0 = 0.2, double thr1 = 0.8);

    //! get the parabola width
    int getW(){ return d_w;};

    //! get the parabola height
    int getH(){ return d_h;};



    //set
    void setParabola();
    void setParabola(int w, int h, int x_direction = 1);

    //public variable
    double m_rTh0, m_rTh1; /// the ratio of the 0, 1 threshold  

};

} //namespace TUVision
#endif // __TUVISION_CPARABOLA_H_
