/***************************************************************************
                          CExceptionFile.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CExceptionFile.h"

using namespace std;
using namespace TUVision;


/**********************************************************/
/*! 
 *   Constructs the exception. The given "filename"
 *   is used to create a description of the problem.
 *
 *   \param filename  name of the file causing the problem
 *   \param add_infos additional description of the 
 *                    problem
 */
/**********************************************************/

CExceptionFileOpen::CExceptionFileOpen (const string &filename,
                                        const string &add_infos)
                                        : CExceptionFile("Cannot open file \"")
{
    d_what += filename;
    d_what += "\". ";
    d_what += add_infos;
}


/**********************************************************/
/*! 
 *   Constructs the exception. The given "filename"
 *   is used to create a description of the problem.
 *
 *   \param filename  name of the file causing the problem
 *   \param add_infos additional description of the 
 *                    problem
 */
/**********************************************************/

CExceptionFileRead::CExceptionFileRead (const string &filename,
                                        const string &add_infos)
                                        : CExceptionFile("Cannot read from file \"")
{
    d_what += filename;
    d_what += "\". ";
    d_what += add_infos;
}


/**********************************************************/
/*! 
 *   Constructs the exception. The given "filename"
 *   is used to create a description of the problem.
 *
 *   \param filename name of the file causing the problem
 *   \param add_infos additional description of the 
 *                    problem
 */
/**********************************************************/

CExceptionFileWrite::CExceptionFileWrite (const string &filename,
                                          const string &add_infos)
                                          : CExceptionFile("Cannot write to file \"")
{
    d_what += filename;
    d_what += "\". ";
    d_what += add_infos;
}


/**********************************************************/
/*! 
 *   Constructs the exception. The given "filename"
 *   is used to create a description of the problem.
 *
 *   \param filename  name of the file causing the problem
 *   \param add_infos additional description of the 
 *                    problem
 */
/**********************************************************/

CExceptionFileHandle::CExceptionFileHandle (const string &filename,
                                            const string &add_infos)
                                            : CExceptionFile("Cannot handle file \"")
{
    d_what += filename;
    d_what += "\". ";
    d_what += add_infos;
}

