/***************************************************************************
                          CFileReadRegistrator.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CFileReadRegistrator.h"
#include "tuv/CFileReadRegistry.h"

using namespace TUVision;

/*! registers the file reader in the registry.
 */
CFileReadRegistrator::CFileReadRegistrator():d_len(0)
{
    CFileReadRegistry& registry=CFileReadRegistry::getRegistry();

    registry.registerReader(this);
}

/*! unregisters the file reader from the registry.
 *  currently, the file readers are automatically removed from
 *  the registry.
 */
CFileReadRegistrator::~CFileReadRegistrator()
{
}

/*! Checks if the registry entry starts with the passed in data. 
 *  Default implementation.
 */
bool 
CFileReadRegistrator::startsWith(int max_len, const unsigned char* id)
{

    const int len = getLength();
    const unsigned char *fileid = getID();

    // false if length greater than input array anyway.
    if(len>max_len)
        return false;

    int i;
    bool equal=true;
    for(i=0;i<len;++i) {
        if(fileid[i]!=id[i]) {
            equal=false;
            break;
        }
    }
    return equal;
}
