/***************************************************************************
                          CFileReadRegistry.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Eric Sommerlade
    email                : tuvisionlib@tuvision.de
    origin               : Studienarbeit/Diplomarbeit Eric Sommerlade

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CFileReadRegistry.h"
#include "tuv/CFileReadRegistrator.h"

#include <vector>

using namespace TUVision;
using namespace std;
/***********************************************************************/



static vector<CFileReadRegistrator*> registry_list;

/***********************************************************************/
CFileReadRegistry& 
CFileReadRegistry::getRegistry()
{
    static CFileReadRegistry registry;
    return(registry);
}    

/***********************************************************************/
CFileReadRegistry::CFileReadRegistry()
{
    // printf("registry init...\n");
}

/***********************************************************************/
CFileReadRegistry::~CFileReadRegistry() 
{
    // fileread class registrators are destroyed by registrators
}

/***********************************************************************/
void 
CFileReadRegistry::registerReader(CFileReadRegistrator* registrator)
{
    registry_list.push_back(registrator);
}

/***********************************************************************/
CFileReadRegistrator*
CFileReadRegistry::getReader(int len, const unsigned char* id) const
{
    vector<CFileReadRegistrator*>::const_iterator i;

    for(i=registry_list.begin();i<registry_list.end();++i) {
        if((*i)->startsWith(len,id))
            break;
    }
    if(i==registry_list.end())
        return(0);
    return (*i);

}

