/***************************************************************************
                          CFileReadUtils.cpp  -  description
                             -------------------
    begin                : 29.11.2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : tuvisionlib@tuvision.de
    origin               : Bildverarbeitung 1, WS 2001/2002

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CFileReadUtils.h"
#include "tuv/CImageByteGray.h"
#include "tuv/CImageByteRGB.h"
#include "tuv/CFileReadAll.h"
#include "tuv2d/COperatorRGB.h"
#include "tuv/CExceptionFile.h"

using namespace TUVision;
using namespace std;

CImageByteGray * TUVision::readImageByteGray(const string &filename)
throw (CException)
{
    CFileReadAll fileReader;

    fileReader.open(filename);
    CImage *inputImage = fileReader.read();
    fileReader.close();

    CImageByteGray *inputGrayimage=0;
    CImageByteRGB  *inputRGBimage = dynamic_cast<CImageByteRGB*>(inputImage);

    if(inputRGBimage != NULL){
        inputGrayimage = new CImageByteGray(convertToGray(*inputRGBimage));
        delete inputImage;
    } else {
        inputGrayimage = dynamic_cast<CImageByteGray*>(inputImage);
        if(inputGrayimage == NULL)
            throw CExceptionFileHandle (filename, "Image is not RGB and not Gray!");
    }

    return inputGrayimage;
}

CImageByteRGB  * TUVision::readImageByteRGB (const string &filename)
throw (CException)
{
    CFileReadAll fileReader;

    fileReader.open(filename);
    CImage *inputImage = fileReader.read();
    fileReader.close();

    CImageByteGray *inputGrayimage;
    CImageByteRGB *inputRGBimage=0;

    inputGrayimage = dynamic_cast<CImageByteGray*>(inputImage);
    if(inputGrayimage != NULL){
        inputRGBimage = new CImageByteRGB(convertToRGB(*inputGrayimage));
        delete inputImage;
    } else {
        inputRGBimage = dynamic_cast<CImageByteRGB*>(inputImage);
        if(inputRGBimage == NULL)
            throw CExceptionFileHandle (filename, "Image is not RGB and not Gray!");
    }

    return inputRGBimage;

}
