/***************************************************************************
                          CExtractorCentroid.cpp  -  description
                             -------------------
    begin                : 10.04.2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : tuvisionlib@tuvision.de, f.wenzel@gmx.net
    origin               : Diplomarbeit Fabian Wenzel

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library's internal version. It is   *
 *   not permitted to publish this file at this point of time as the       *
 *   algorithms are meant to be shared between TUHH Vision Systems         *
 *   members only.                                                         *
 *                                                                         *
 ***************************************************************************/

#include "tuv2d/CExtractorCentroid.h"

using namespace TUVision;

CExtractorCentroid::CExtractorCentroid(){
}

CVertex2d *CExtractorCentroid::calcCentroid(const CImageByteGray *img){
    CVertex2d *centroid = new CVertex2d;
    long xcent=0;
    long ycent=0;
    int sum   =0;
    const unsigned char *row;
    int x,y;
    for(y=0;y<img->getH();y++){
        row=img->getRow(y);
        for(x=0;x<img->getW();x++){
            xcent+=(x+1) * row[x];
            ycent+=(y+1) * row[x];
            sum  +=row[x];
        }
    }
    centroid->x=(double) xcent / (double) sum  -1;
    centroid->y=(double) ycent / (double) sum  -1;

    return centroid;
}
