/***************************************************************************
                          CCurve.cpp  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv2d/CCurve.h"
#include "tuv/CImageByteGray.h"

using namespace TUVision;
using namespace std;

/**********************************************************/
/*! 
 *    scan curves in edge img and store them in curve.
 *
 *    \param img the input image contains a curve
 */
/**********************************************************/
void 
CCurve::getCurveFromImage( const CImageByteGray &img) {

    int w = img.getW(); // image width
    int h = img.getH(); // image height
    const unsigned char *img_ptr; // pointer to image date used in the loop

    CPointXY tpt; //tmp point
    int x , y;
    for( y = 0 ; y < h ; y++) { // loop through height
        img_ptr = img.getRow(y);
        for(x = 0 ; x < w ; x++) {  // loop through width
            if(img_ptr[x] == 255) {   // if special condition
                tpt.x = x ;
                tpt.y = y ;
                vecCurvePoints.push_back(tpt);
            } // special condition was full filled
        } // end x, width
    } // end y, height
    CurveLength = vecCurvePoints.size();
    CurveStartPoint = CPointXY(*vecCurvePoints.begin());
    CurveEndPoint = CPointXY(*vecCurvePoints.end());
}
