/***************************************************************************
                          COperatorNormalize.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv2d/COperatorNormalize.h"
#include "tuv2d/CCorrelator.h"
#include "tuv/CImageByteGray.h"
#include <cmath>
#include <cstdio>

//using namespace std;
using namespace TUVision;


/**********************************************************/
/*!
 *   Constructor.
 */
/**********************************************************/

COperatorNormalize::COperatorNormalize()
{
}


/**********************************************************/
/*!
 *   Destructor.
 */
/**********************************************************/

COperatorNormalize::~COperatorNormalize()
{
}


/**********************************************************/
/*!
 *   Calculate the normalization for the given image object
 *   (byte gray). 
 *
 */
/**********************************************************/

void COperatorNormalize::normalizeImage (CImageByteGray &img, double avg0, double var0)
{

    /*	
    double avg = calcAvg(img);

    double var = calcVar(img, avg );

    unsigned char* pixel;

    int tmp=0;

    int h = img.getH();
    int w = img.getW();
    int i, j;

    for(j=0;j<h;j++)
    {
    pixel=img.getRow(j);
    for(i=0;i<w;i++)
    {
    tmp = (*pixel - (int)avg);
    //tmp *= tmp; 
    if( *pixel > avg )
    *pixel++ = (int)(avg0 + (int)(tmp*sqrt( (var0 ) / var )));
    else
    *pixel++ = (int)(avg0 - (int)(tmp*sqrt( (var0 ) / var )));
    }
    }
    */
    //avg0 = 100.0;
    //var0 = 1000;
    double avg = calcAvg(img);
    printf("avg %g \n", avg);

    double var = calcVar(img, avg );
    printf("var %g \n", var);

    //	printf("avg %g var %g avg0 %g var0 %g\n", avg, var ,avg0, var0 );

    double varq = var0/var;
    varq  =  sqrt(varq)*256.0;
    printf("varq %g \n" , varq);

    unsigned char* pixel;

    int tmp=0;

    int h = img.getH();
    int w = img.getW();
    int i, j;

    for(j=0;j<h;j++)
    {
        pixel=img.getRow(j);
        for(i=0;i<w;i++)
        {
            tmp = (*pixel - (int)avg);
            //tmp *= tmp; 
            if( *pixel > avg )
                *pixel++ = (int)avg0 + (int(tmp*varq)>>8);
            else
                *pixel++ = (int)avg0 - (int(tmp*varq)>>8);
        }
    }
}

